
-- A few useful SQL functions

local closeDb=bd.closeDb
local type,unpack,fmt=type,table.unpack,string.format
local _G=_G
local _ENV={}

local function select(conn,sql,func)
   local env
   if type(conn) == "function" then env,conn = conn() end
   local cur,err,err2=conn:execute('SELECT '..sql)
   if cur then
      local t={func(cur)}
      cur:close()
      if env then closeDb(env, conn) end
      return unpack(t)
   end
   if env then closeDb(env, conn) end
   if err2 then err=fmt("%s: %s",err,err2) end
   return nil,err
end

local function find(cur) return cur:fetch() end
function _ENV.find(conn,sql) return select(conn,sql,find) end
function _ENV.findt(conn,sql,t)
   local function find(cur) return cur:fetch(t,"a") end
   return select(conn,sql,find)
end

function exist(name)
   return _G.bd.hasDb(name)
end

function open(name, options)
   local conn
   name=_G.bd.datasource(name)
   local env,err = _G.luasql.sqlite()
   if env then
      conn, err = env:connect(name, options)
      if conn then return env,conn end
      env:close()
   end
   _G.error(fmt("Cannot open %s: %s",name,err),2)
end

function close(env,conn)
   conn:close()
   env:close()
end

function dir()
   return _G.bd.datasource()
end

_ENV.select=select


return _ENV
