<?lsp

local fmt=string.format

local headerContent
if not page.headerContent or cmsIsAdmin then
   local f = app.cmsdocs.open("sky.txt", "rb")
   if f then
      page.headerContent=f:read"*a"
      headerContent=page.headerContent
      f:close();
   elseif cmsIsAdmin then
      headerContent="Create sky.txt in your cmsdocs directory"
   else
      headerContent=""
   end
else
   headerContent=page.headerContent
end


local curUri=request:uri()
local tinsert=table.insert 
local function toHref(name,uri,selT)
   if type(uri) == "string" then
      if uri == curUri then
         if selT then selT.selected=true end
         return fmt("<li><a href='%s' class='active'>%s</a></li>",uri,name)
      end
      return fmt("<li><a href='%s'>%s</a></li>",uri,name)
   end
   local selT2={}
   local t={}
   local uris=uri.ut
   for k,v in ipairs(uri.nt) do
      tinsert(t,toHref(v,uris[k],selT2))
   end
   tinsert(t,"</ul></li>")
   if selT and selT2.selected then selT.selected=selT2.selected end
   return fmt("<li><span%s>%s</span><ul>",selT2.selected and
              " class='active'" or "",
              name)..table.concat(t)
end


local function emitLi(names,uris)
   for k,v in ipairs(names) do
      write("<li>",toHref(v,uris[k]),"</li>")
   end
end

local function emitArchive()
   local month=cmsMonth
   for _,year in ipairs(app.archList) do
      local y = year.y
      write("<li>",toHref(y,"/blog/"..y),"</li><ul>")
      for _,m in ipairs(year.m) do
         write("<li>",toHref(month(m),fmt("/blog/%s/%s",y,m)),"</li>")
      end
      print("</ul>")
   end
end


local function emitContent()
   if cmsBlog then
      local permalink,id,date,cat,subj,name,data=cmsBlog()
      while permalink do
         local pi = cmsPostedIn(cat)
         write("<div class='post'><h2><a href='",
                        permalink,
                        "'>",
                        subj,
                        "</a></h2>",
                        data,
                        "<p>",
                        pi and pi or "",
                        os.date(" %A, %B %dth, %Y ", date),
                        #name > 0 and (" by "..name) or "",
                        "</p>")
         local title,fbKey=cmsFbComments()
         if title then
            if fbKey then
               write'<a name="fbcomments"></a>'
               app.emitFbCommentBox(write,id,fbKey)
            else
               write("<p><a href='",permalink,"#fbcomments'>",title,"</a></p>")
            end
         end
         write"</div>"
         permalink,id,date,cat,subj,name,data=cmsBlog()
      end
   else
      print("<div class='post'>")
      cmsEmitPage()
      print("</div>")
   end
end
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:fb="http://www.facebook.com/2008/fbml">
<head>
<title><?lsp=cmsTitle?></title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link href="/theme/sky.css" rel="stylesheet" type="text/css" />
<?lsp=cmsHeader?>
<script src="/theme/sky.js" type="text/javascript"></script>
</head>
<body>
<div class="wrapper">
<div class="header"><?lsp=headerContent?></div>
<div class="left">
<?lsp if cmsShowAdmLinks then ?>
<div class="infobox"><h2>Edit</h2><div id="cmsManage"></div></div>
<?lsp end ?>
<div id="menu" class="infobox">
<h2>Links</h2>
<ul><?lsp emitLi(app.links.names, app.links.uris) ?></ul>
</div>
<?lsp
if cmsIsBlog then 
if app.cats then
?>
<div class="infobox">
<h2>Categories</h2>
<ul><?lsp emitLi(app.cats.names,app.cats.uris)?></ul>
</div>
<?lsp end ?>
<div class="infobox">
<h2>Archive</h2>
<ul><?lsp emitArchive() ?></ul>
</div>
<br />
<?lsp end -- if cmsIsBlog
?>
</div>
<div class="center">
<?lsp emitContent() ?>
</div>
<div class="clear"></div>
 </div>
 <div class="footer">
<?lsp if cmsRssUri then
  write("<a href='",cmsRssUri,"' title='Feed URL'><img src='/images/feedIcon.png' alt='RSS feed' style='margin: -5px 0 0 1em;border:none;float:left'/></a>")
end
?>
<p>Powered by the <a target="rtl" href="http://realtimelogic.com/products/barracuda-application-server/">Barracuda Application Server</a> and the <a target="rtl" href="http://realtimelogic.com/products/sharkssl/">SharkSSL Embedded SSL Stack</a></p>
<!-- Design by pierdtimp.ro http://www.pierdtimp.ro -->
</div>
<br />
<br />
<?lsp cmsEmitGA() ?>
</body>
</html>
