<?lsp

local fmt=string.format

local headercontent
if not app.passion or cmsIsAdmin then
   local f = app.cmsdocs.open("passion.txt", "rb")
   if f then
      app.passion=f:read"*a"
      headercontent=app.passion
      f:close();
   elseif cmsIsAdmin then
      headercontent="In your cmsdocs directory: create passion.txt</p>"
   else
      headercontent=""
   end
else
   headercontent=app.passion
end

local function toHref(name,uri)
   return fmt("<a href='%s'>%s</a>\n",uri,name)
end

local function emitBlogLinks()
-- page.cats=0 -- Enable when testing
-- page.archList=0 -- Enable when testing
   if app.cats then
      if page.cats ~= app.cats then -- If categories updated
         page.cats = app.cats
         local t={}
         local uris=app.cats.uris
         for k,v in ipairs(app.cats.names) do
            table.insert(t, toHref(v, uris[k]))
         end
         page.catlinks=fmt("<span class='headertext2'>Categories</span><pre>%s</pre>",table.concat(t))
      end
      print(page.catlinks)
   end
   print("<span class='headertext2'>Archives</span><pre>")
   if page.archList ~= app.archList then -- If archive list updated
      page.archList = app.archList
      local t={}
      local month=cmsMonth
      for _,year in ipairs(app.archList) do
         local y = year.y
         table.insert(t,toHref(fmt("<b class='negative'>%s</b>",y),"/blog/"..y))
         for _,m in ipairs(year.m) do
            table.insert(t,toHref(month(m),fmt("/blog/%s/%s",y,m)))
         end
      end
      page.arch=table.concat(t)
   end
   write(page.arch,"</pre>")
   
end
 
local function emitContent()
   if cmsBlog then
      local permalink,id,date,cat,subj,name,data=cmsBlog()
      while permalink do
         local pi = cmsPostedIn(cat)
         write("<span class='headertext1'><a href='",
                        permalink,
                        "'>",
                        subj,
                        "</a></span><p>",
                        os.date(" %A, %B %dth, %Y ", date),
                        #name > 0 and (" by "..name) or "",
                        "</p>",
                        data,
                        "<p>",
                        pi and pi or "",
                        "</p>")
         local title,fbKey=cmsFbComments()
         if title then
            if fbKey then
               write'<a name="fbcomments"></a>'
               app.emitFbCommentBox(write,id,fbKey)
            else
               write("<p><a href='",permalink,"#fbcomments'>",title,"</a></p>")
            end
         end
         write"<hr class='blgsep'/>"
         permalink,id,date,cat,subj,name,data=cmsBlog()
      end
   else
      cmsEmitPage()
   end
end
 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:fb="http://www.facebook.com/2008/fbml">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?lsp=cmsTitle?></title>
<link rel="stylesheet" href="/theme/passion.css" type="text/css" />
<?lsp=cmsHeader?>
</head>

<body>
<!-- Master Container: Centered and 700px wide -->
<div id="container">
    
    <!-- Site Top Header -->
    <div id="topheader">
    <span id="title"><?lsp=headercontent?></span>
	</div>
    
	<!-- Site navigation buttons -->
	<div id="navcontainer">
<?lsp

local moreLinks
local subLinkName
local subLinks 
do
   local uriN=0
   local curURI=request:uri()
   local names=app.links.names
   for k,v in ipairs(app.links.uris) do
      local url
      if type(v) == "string" then
         url=v
      else
         url=v.ut[1]
         if not subLinkName then
            local found
            for _,u in pairs(v.ut) do
               if curURI == u then
                  found=true
                  break
               end
            end
            if found then
               subLinkName=names[k]
               subLinks={}
               local n=v.nt
               for k,v in pairs(v.ut) do
                  -- Stop at sub menu level 2
                  if type(v) == "string" then
                     table.insert(subLinks,fmt("<a href='%s'>%s</a>",v,n[k]))
                  end
               end
            end
         end
      end
      if url then
         local lnk=fmt("<a href='%s'>%s</a>",url,names[k])
         if uriN > 5 then
            if not moreLinks then moreLinks = {} end
            table.insert(moreLinks,lnk)
         else
            write("<div class='navitem'>",lnk,"</div>")
         end
         uriN = uriN + 1
      end
   end
end
?> 
    </div>
    <!-- End of Site Navigation Buttons -->
    
    <!-- Main content container -->
    <div id="main">
        <!-- The sidebar for news etc -->
<?lsp
if cmsIsBlog or moreLinks then
   print"<div id='sidebar'>"
   if moreLinks then
      print("<span class='headertext2'>Links</span><pre>")
      print(table.concat(moreLinks, "\n"))
      print"</pre>"
   end
   if subLinks then
      response:write("<span class='headertext2'>",subLinkName,"</span><pre>")
      print(table.concat(subLinks, "\n"))
      print"</pre>"
   end
   if cmsIsBlog then
      emitBlogLinks()
   end
   print"</div>"
end
?>
      <!-- End of Sidebar -->	 
      <br /><br />
      <?lsp emitContent() ?>		

    </div>
    <!-- End of main container -->
    
    <!-- Footer -->
    <div id="footer">
<?lsp
if cmsIsAdmin then
   if cmsShowAdmLinks then
      print"<div id='cmsManage' style='float:left'></div>"
   end
   print"<a href='/private/manage/' title='Configure Application'>Configure</a>"
else
   print"Powered by the <a href='http://FuguHub.com/'>FuguHub Web Server</a>"
end
if cmsRssUri then
   write("<a id='feedurl' href='",cmsRssUri,"' title='Feed URL'><img src='/images/feedIcon.png' alt='RSS feed'/></a>")
end
?>


    </div>
    <!-- End of footer -->
<div id="rtlinfo">
<p>Powered by the <a target="rtl" href="http://realtimelogic.com/products/barracuda-application-server/">Barracuda Embedded Web Server</a> and the <a target="rtl" href="http://realtimelogic.com/products/sharkssl/">SharkSSL Embedded SSL Stack</a></p>
</div>
</div>
<!-- End of master container -->
<?lsp cmsEmitGA() ?>
</body>
</html>
