<?lsp

local links={
   {"User Management",
      {
         {"/rtl/protected/admin/users.lsp","All Users",
[[
List of users in the FuguHub user database.<br/>Click the username if you want to edit the user's settings.
]]
         },
         {"/rtl/protected/admin/user.lsp",addUserTxt or "Add User",
[[
<p>Add a user to the FuguHub user database.</p>
Adding users to the FuguHub user database does not directly imply that they can access and/or edit resources. Access rights are given to roles and a user can be a member of one or more roles.
]]
         },
         {"/rtl/protected/admin/roles.lsp","Manage Roles",
[[
<p>Add, edit, or delete roles.</p>
Roles are the connection between users and their access rights. You give users access rights by adding users to one or several roles. You can create any number of roles. 
]]
         },
         {"/rtl/protected/admin/wfsconstr.lsp","WFS Constraints",
[[
<p>Manage Access Control Lists (ACLs) for the Web File Server.</p>The permissions you create are for roles and not directly for the users. Users are given permission when they are added to the role that are associated with the ACL.
]]
         },
         {"/rtl/protected/admin/tunnelconstr.lsp","Tunnel Constraints",
[[
      <p>Manage Access Control Lists (ACLs) for the HTTPS tunnel.</p>The permissions you create are for roles and not directly for the users. Users are given permission when they are added to role(s).
]]
         },
         {"/rtl/protected/admin/wizard/","Wizard",
[[
<p>Many new users find it difficult to configure Access Control Lists (ACLs). This wizard includes a simplified ACL manager that makes it easier to add users and set the user's permission(s).</p><p>You should use the simplified ACL manager if you are new to Access Control Lists and you plan on adding users with limited access to your computer.</p>
]]
         },
         {"/rtl/protected/admin/importusers.lsp","Import Users",
[[
<p>Import users by uploading a CSV (comma-separated value) file.</p>
]]
         },

         {"/rtl/protected/admin/masterpwd.lsp","Master Password",
[[
<p>Set a master password and encrypt all user credentials.</p>
]]
         },


   }},
   {"Application Manager",
      {
         {"/rtl/protected/admin/appmgr/","Applications",
[[
<p>List all auxiliary applications registered by FuguHub.</p>
The FuguHub server function similar to an operating system in that the server can load, start, and stop auxiliary applications such as the FuguHub Content Management System (CMS).

]]
         },
         {"/rtl/protected/admin/appmgr/loadapp.lsp","Load",
[[
<p>Load new application(s).</p>FuguHub applications are stored as ZIP files in the applications sub directory. You can optionally download additional applications and place the applications in the applications sub directory.
]]
         },
         {"/rtl/protected/admin/appmgr/newapp.lsp","New",
            "Create your own application (for experts)."
         },
   }},
   {"Miscellaneous",
      {
         {"/rtl/protected/admin/customize.lsp","Customize Server",
[[
Customize the FuguHub user interface.
]]
         },
         {"/rtl/protected/admin/smtp.lsp","SMTP Server",
[[
Configure SMTP and enable email support in FuguHub.
]]
         },
         {"/rtl/protected/admin/misc.lsp","WebDAV",
[[
Set the timeout value for the WebDAV session URL.
]]
         },
         {"/rtl/protected/admin/tracker/","Login Tracker",
[[
<p>Show statistics on successful and failed logins.</p>Do not worry if you see a high number of unsuccessful login attempts. FuguHub includes anti hacker technology that prevents users from hacking into your server.
]]
         },
         {"/rtl/protected/admin/trace/","Trace",
[[
<p>The FuguHub server's trace is a collection of files automatically created and maintained by the server. A new file is created each time the server is restarted.</p>
<p>Applications running in the server print various types of information which are collected in the trace files.</p>
<p>The trace files are not the same as a server log, but you can enable HTTP logging in the trace file by enabling HTTP tracing using the Simple Debugger.</p>
<p>You can delete the trace files which are stored in the "trace" subdirectory.</p>
]]            
         },
   }},
   {"Developer Tools",
      {
         {"/rtl/protected/admin/tracelogger/","Trace Logger",
[[
<p>The Trace Logger shows information printed to the trace in real-time. The tool is typically used by developers when developing LSP applications. The LSP function trace(...) emits data to the trace, which is shown in real-time when the Trace Logger is active.</p>
<p>The Trace Logger can enable and disable HTTP logging. The various buttons in this tool allow you to enable logging of HTTP headers received and sent. Please note that the HTTP headers are also sent to the active trace file.</p> 
]]            
         },
   }}
}

?>
<br />
      </div><!--content-->
  </div><!--container-->
  <div id="sidebar">
    <ul>
<?lsp
for _,x in ipairs(links) do
   response:write('<li><span>',x[1],'</span></li>')
   for _,y in ipairs(x[2]) do
      response:write('<li><a ',title:find(y[2],1,true) and "class='cur'" or "",
                     ' href="',y[1],'">',y[2])
      if enablemenuhelp then
         response:write('<span>',y[3],'</span>')
      end
      response:write('</a></li>')
   end
end
?>
    </ul>
  </div><!--sider-->
</div><!--wrapper-->
</body>
</html>
