<?lsp

-- The extra header we need ".header" to add.
headerdata=[[
<link href="style.css" rel="stylesheet" type="text/css" />
<link href="../style.css" rel="stylesheet" type="text/css" />
<style type="text/css" media="screen">
#app{border:1px solid gray;padding: 0;width: 80%;float: left}
</style>
<script>

function showOrHideElem(show, elem)
{
   elem.style.visibility= show ? "visible" : "hidden"; 
};
function showOrHide(show,a,b)
{
   showOrHideElem(show,document.getElementById(a));
   if(b)
      showOrHideElem(show,document.getElementById(b));
};
function show(a,b){ showOrHide(true, a, b); };
function hide(a,b) { showOrHide(false, a, b);};
 

var basepath = "/";

function rsGetStartPath()
{
   return basepath+pathElem.value;
};

var rsHistList = [basepath];
function rsGetHistoryList()
{
   return rsHistList;
};

function rsOnOpen(dir, resource, isDir)
{
   dir = dir+resource;
   if(dir.search(basepath) == 0)
      pathElem.value = dir.substring(basepath.length);
   else
      pathElem.value ="";
   return true;
};

function rsOnShow(dir, resource, isDir)
{
   if(isDir)
      return true;
   return resource.search(/\.zip$/i) < 1 ? false : true;
};


function rsInit()
{
  return {
     onOpen:rsOnOpen,
     onShow:rsOnShow,
     regExp:'/$|\.zip$',
     getStartPath: rsGetStartPath,
     getHistoryList:rsGetHistoryList};
};

function startResourceSelector()
{
   var w = window.open(
      '../../rs.html?init=rsInit',
      "SelApp",
      "scrollbars=1, toolbar=0, status=0, resizable=1, width=640, height="+(screen.height/2));
   if(!w) alert('Your browser is blocking the pop-up window');   
};

onload = function()
{
  pathElem = document.getElementById("path");
}
</script>
]]

title="Menu: Administrator Panel: New Application"
response:include"../.header.lsp"


-- Returns path1 + path2
function addPath(path1, path2)
   local path = path1.."/"..path2
   return path:gsub("//","/") -- just in case
end
 

local io = bd.baseio

local error

-- Cache form data and trim of all whitespace at both ends of the form values
local data = request:data()
for k,v in pairs(data) do
   local vt = string.match(v, "^%s*(.-)%s*$")
   data[k] = #vt > 0 and vt:gsub("[<>]","") or nil -- Remove element if empty
end

 -- Emit full form if we have name and path
local emitFull = false

if data.name and data.path then -- if form POST data
   local st = io:stat(data.path)
   if st then
      if not string.find(data.name, "%s") then
         if not bd.appmgr.list[data.name] then
            emitFull = true
            -- If not a director or if posting a full form
            -- assume ZIP file if not a directory i.e. a deployed BD app.
            if not st.isdir or (data.type and data.rootapp ~= nil) then
               local name = data.name
               local path = data.path
               local f
               local appio,error=ba.mkio(io,data.path)
               if appio then
                  if appio:resourcetype() == "zip" then
                     bd.appmgr.load(name, path)
                     response:sendredirect("./?n="..name)
                     return
                  end
                  f,error=appio:open(".appinfo","wb")
               end
               if f then
                  -- Remove elements not needed in config file and save.
                  data.name = nil
                  data.path = nil
                   -- Translate to boolean
                  data.rootapp = data.rootapp == "true" and true or false
                  data.hidden = data.hidden == "true" and true or false
                  f:write(json.encode(data)) -- Save the config file
                  f:close()
                  bd.appmgr.load(name, path)
                  response:sendredirect("./?n="..name)
                  return
               else
                  error = error or ""
                  error = "Cannot save "..data.path.."/.appinfo: "..error
               end
            end
            if not error then -- Try to load the config file if it exists.
               local f = io:open(addPath(data.path,"/.appinfo"),"rb")
               if f then
                  local info = json.decode(f:read"*a")
                  f:close();
                  if info then
                     -- Translate to string
                     info.rootapp = info.rootapp and "true" or "false"
                     info.hidden = info.hidden and "true" or "false"
                     -- Copy all values to the form data table.
                     for k,v in pairs(info) do
                        data[k] = v;
                     end
                  end
               end
            end
         else
            error = "An application with this name is already loaded"
         end
      else
         error = "Application cannot contain whitespace characters"
      end
   else
      error = "Invalid directory or ZIP name"
   end
end

-- Set default values if not defined
data.name = data.name or ""
data.path = data.path or ""
data.type = data.type or "html"
data.copyright = data.copyright or ""
data.description = data.description or ""
data.link = data.link or ""
data.rootapp = data.rootapp or "false"
data.hidden = data.hidden or "false"

if error then
   print("<p style='font-weight:bold;color:red'>Error: ", error, ".</p>")
end
emitHelpBut("appmgr",true, "New")
?>
<h1>Add a New Application</h1>
<p><br/></p>
<form method="post">
<table>
  <tr>
    <td>
      Application&nbsp;name:
    </td>
    <td>
      <?lsp if emitFull then print(data.name) end ?>
        <input type="<?lsp= emitFull and "hidden" or "text"?>" size="40" name="name" value="<?lsp=data.name?>" title="Enter name of application. Spaces are not allowed."/>
    </td>
  </tr>
  <tr>
    <td>
      Directory/ZIP:
    </td>
    <td>
      <?lsp if emitFull then print(data.path) end ?>
        <input id="path" type="<?lsp= emitFull and "hidden" or "text"?>" size="24" name="path" value="<?lsp=data.path?>" title="Enter the path to the start of application directory" />
        <?lsp if not emitFull then?>
          <input type="button" value="browse" onclick="startResourceSelector()" title="Open the resource selector and browse the file system" />
      <?lsp end ?>
  </td>
  </tr>
  <?lsp if emitFull then ?>

  <tr>
    <td>
      Root application:
    </td>
    <td>
      <input type="radio" name="rootapp" value="false" onclick="show('HiddenLink');" <?lsp= data.rootapp ~= "true" and "checked" ?> title="Install the application as a standard Barracuda application"/> no &nbsp;&nbsp;
     <input type="radio" name="rootapp" value="true" onclick="hide('HiddenLink');" <?lsp= data.rootapp == "true" and "checked" ?> title="SPECIALIZED APPLICATION TYPE: Install in the web-server's top root directory" /> yes
    </td>
  </tr>

  <tr id="HiddenLink" style="visibility:<?lsp=data.rootapp == "true" and "hidden" or "visible"?>">
    <td>
      Hidden link:
    </td>
    <td>
     <input type="radio" name="hidden" value="false" <?lsp= data.hidden ~= "true" and "checked" ?> title="FuguHub shows the link to this application"/> no &nbsp;&nbsp;
     <input type="radio" name="hidden" value="true" <?lsp= data.hidden == "true" and "checked" ?> title="Hidden application" /> yes
    </td>
  </tr>

  <tr>
    <td>
      Application type:
    </td>
    <td>
      <input type="radio" name="type" value="html" <?lsp= data.type == "html" and "checked"?> title="Create a static HTML application"/> HTML &nbsp;&nbsp;
      <input type="radio" name="type" value="lsp" <?lsp= data.type == "lsp" and "checked"?> title="Create a dynamic Lua Server Pages application"/> LSP
    </td>
  </tr>
  <tr>
    <td>
      Copyright:
    </td>
    <td>
      <textarea name="copyright" cols="40" rows="4" title="Enter any copyright information here"><?lsp=data.copyright?></textarea>
    </td>
  </tr>
  <tr>
    <td>
      Description:
    </td>
    <td>
      <textarea name="description" cols="40" rows="8" title="Enter application description"><?lsp=data.description?></textarea>
    </td>
  </tr>
  <tr>
    <td>
      Home page link:
    </td>
    <td>
      <input type="text" size="40" name="link" value="<?lsp=data.link?>" title="Application designers can enter the URL to the homepage/download page"/>
    </td>
  </tr>
   <?lsp end -- emitFull
   ?>
  <tr>
    <td colspan="2"><input style="text-align:center" type="submit" value="Submit"/></td>
  </tr>
</table>
</form>
<?lsp response:include"../.footer.lsp" ?>
