<?lsp

local fmt=string.format
local sqlutil=require"sqlutil"
local env,conn = bd.openDb"bd"
local data=bd.trim(request:data())
local tinsert=table.insert

local function getOffset()
   if data.offset then
      offset=tonumber(data.offset)
      if offset then return offset end
   end
   return 0
end

local function listaction(cur)
   local key,name = cur:fetch()
   if key then
      _emit'<td><fieldset id="lists"><legend>Move selected contacts to list:</legend><select name="lk">'
      while key do
         response:write('<option value="',key,'">',name,'</option>')
         key,name = cur:fetch()
      end
      response:write'</select><input type="submit" name="move" value="Move"/></fieldset></td>'
   end
end

function emitlists()
   local size=tonumber(sqlutil.find(conn,"count(*) FROM maillist"))
   if size > 1 then
      sqlutil.select(conn,'key,name FROM maillist', listaction)
   end
end

function showList()
   local size=tonumber(sqlutil.find(conn,"count(*) FROM mailcontact"))
   local offset
   if size > 100 then
      offset = getOffset()
      local nav=data.nav
      if nav then
         nav=tonumber(nav)
         if nav then
            offset = nav > 0 and (nav+100 < size and nav or size-100) or 0
         end
      elseif offset < 0 then offset=0
      elseif offset+100 >size then offset=size-100
      end
   else
      if size == 0 then
         empty=true
         response:forward".help.lsp"
      end
      offset=0
   end
?>
<form method="GET">
<?lsp if size > 100 then ?>
<div class="roundedbox" id="menu">
<table id="stdbuts"><tr>
<td><button class="nav" title="Backward" type="submit" name="nav" value="<?lsp=offset-100?>" ><img src="../img/backward.png"/></button></td>
<td><?lsp=fmt("%u-%u of %u",offset,offset+100,size)?></td>
<td><button class="nav" title="Forward" type="submit" name="nav" value="<?lsp=offset+100?>" ><img src="../img/forward.png"/></button></td>
<td id="searchcont">
<fieldset>
<legend><b> Search </b></legend>
<input id="search" type='input' size='50'/>
<input type="hidden" name="offset" value="<?lsp=offset?>" />
<input type="submit" name="clear" value="Clear" />
</fieldset> 
</td>
</tr></table>
</div>
<?lsp end ?>
</form>
<form method="POST">
<div id='fstab'><table><thead><tr><th>E-Mail</th><th>First Name</th><th>Last Name</th><th>List Name</th></tr></thead><tbody>
<?lsp
   local function action(cur)
      local key,email,firstname,lastname,listname = cur:fetch()
      while key do
         listname=listname or ""
         response:write('<tr><td><input class="rmarg" type="checkbox" name="k" value="',key,'"/><a href="list.lsp?subkey=',key,'">',email,'</a></td><td>',firstname,'</td><td>',
                        lastname,'</td><td>',listname,'</td></tr>')
         key,email,firstname,lastname,listname  = cur:fetch()
      end
   end
   sqlutil.select(conn,fmt('%s LIMIT %u,100',"key,email,firstname,lastname,(SELECT name FROM maillist WHERE key=listkey) FROM mailcontact ORDER BY email",offset), action)
?>
</tbody></table></div>
<?lsp if size ~= 0 then ?>
<div class="roundedbox" id="bmenu">
<table><tr>
<?lsp if size > 100 then ?>
<td><button class="nav" title="Backward" type="submit" name="nav" value="<?lsp=offset-100?>" ><img src="../img/backward.png"/></button></td>
<td><?lsp=fmt("%u-%u of %u",offset,offset+100,size)?></td>
<td><button class="nav" title="Forward" type="submit" name="nav" value="<?lsp=offset+100?>" ><img src="../img/forward.png"/></button></td>
<?lsp end ?>
<td><input class="lbut" id="selall" type="button" value="Select All" /></td>
<td><input class="lbut" type="submit" name="delete" value="Delete Selected Contacts" /></td>
<?lsp emitlists() ?>
</tr></table>
<?lsp end ?>
<input type="hidden" name="offset" value="<?lsp=offset?>" >
</form>
</div>
<?lsp
end
-----------------showList------------------------------





headerdata=[[
<link href="../../../fstab.css" rel="stylesheet" type="text/css" />
<style>
#showupload, #cancelupload, #uploadimg{display:none;}
#menu{margin:-5px 5px 10px -5px;min-width:600px;}
#bmenu{margin-top:10px}
.lbut {height:48px; min-width:180px;}
#stdbuts fieldset{display:none;margin-left:40px;}
#searchcont fieldset{float:right}
button.nav{border: 2px solid #F0F0F0; background: transparent;}
button.nav:hover{border: outset 2px gray;}
input.rmarg{margin-right:15px;}
#lists{min-height:35px}
#lists select{min-width:150px;} 
</style>
<script type='text/javascript' src='/rtl/wfm/wfm.js'></script>
<script type='text/javascript' src='editcont.js'></script>
<script type='text/javascript'>
$(function() {
   $("#selall").click(function() {
      $("#fstab input").attr("checked","checked");
      $(this).blur();
   });
   var started=false;
   $("#stdbuts fieldset").show();
   $("#search").keyup(function() {
      $.getJSON("index.lsp", {search:$("#search").attr("value")}, function(resp) {
         var t=$("#fstab tbody");
         t.empty();
         if(!started) {
            started=true;
            $("#fstab th").unbind().fadeTo(0,.80);
         }
         function action(r) {
            bindEditCont($("a",$('<tr><td><input type="checkbox" name="k" value="'+r.k+'"/><a href="list.lsp?subkey='+r.k+'">'+r.e+'</a></td><td>'+r.fn+
              '</td><td>'+r.ln+'</td><td>'+r.l+
              '</td></tr>').
               appendTo(t)));
         }
         resp.forEach(action);
      });
   });

});
</script>
]]
title="Menu: Mail Manager: All Contacts"
response:include"/rtl/.header.lsp"
?>
<?lsp

if data.search then
   local tab={}
   local s=luasql.quotestr(fmt("%%%s%%",data.search))
   local sql=fmt("%s(email LIKE %s) or (firstname LIKE %s) or (lastname LIKE %s) LIMIT 100",
                 "key,email,firstname,lastname,(SELECT name FROM maillist WHERE key=listkey) FROM mailcontact WHERE ",
                 s,s,s)
   local function action(cur)
      local key,email,firstname,lastname,listname = cur:fetch()
      while key do
         listname=listname or ""
         tinsert(tab,{k=key,e=email,fn=firstname,ln=lastname,l=listname})
         key,email,firstname,lastname,listname  = cur:fetch()
      end
   end
   sqlutil.select(conn,sql, action)
   bd.closeDb(env,conn)
   response:json(tab)
end
if data.delete or data.move then
   local tab={}
   for n,v in request:datapairs() do
      if n == "k" and tonumber(v) then
         tinsert(tab,v)
      end
   end
   if #tab > 0 then
      local sql
      if data.delete then
         sql=fmt("DELETE FROM mailcontact WHERE key IN (%s)",table.concat(tab,","))
      elseif data.lk and tonumber(data.lk) then
         sql=fmt("UPDATE mailcontact SET listkey=%s WHERE key IN (%s)", data.lk,table.concat(tab,","))
      end
      if sql then
         local ok,e1,e2=conn:execute(sql)
         if not ok then
            trace("SQL maillist err:",sql," : ",e1,e2)
         end
      end
   end
elseif data.clear and data.offset then
   response:sendredirect("./?offset="..data.offset)
end

showList()
bd.closeDb(env,conn)
response:include".footer.lsp"
?>
