<?lsp

local env,conn
local data=bd.trim(bd.xssfilter(request:data()))
local quote=luasql.quotestr
local fmt=string.format
local tinsert=table.insert
local baseTitle="Menu: Mail Manager: "
title=baseTitle.."Add List"
local listkey
local sqlutil
local mailutil
local function w(...) response:write(...) end
local session=request:session(true)


local function closeDb(uri)
   bd.closeDb(env,conn)
   env,conn=nil,nil
   if uri then
      response:sendredirect(uri)
   end
end

local function getredir()
   local name=data.newname or data.name
   if not name then
      return "list.lsp"
   end
   if data.offset then
      return fmt("list.lsp?name=%s&offset=%s", ba.urlencode(name),data.offset)
   end
   return fmt("list.lsp?name=%s", ba.urlencode(name))
end

local function redir2list()
   closeDb(getredir())
end

local function getOffset()
   if data.offset then
      offset=tonumber(data.offset)
      if offset then return offset end
   end
   return 0
end


local function checkIfUniqueEmail(email)
   return mailutil.findemail(conn,email) == nil and true or false
end


local function showHeader() response:include"/rtl/.header.lsp" end
local function showFooter() response:include".footer.lsp" end

------------------------------------------------------
function showList()
   local description = sqlutil.find(conn,"description FROM maillist WHERE key="..listkey)
   local size=tonumber(sqlutil.find(conn,"count(*) FROM mailcontact WHERE listkey="..listkey))
   local offset
   if size > 100 then
      offset = getOffset()
      local nav=data.nav
      if nav then
         nav=tonumber(nav)
         if nav then
            offset = nav > 0 and (nav+100 < size and nav or size-100) or 0
         end
      elseif offset < 0 then offset=0
      elseif offset+100 >size then offset=size-100
      end
   else
      offset=0
   end

   headerdata=[[
<link href="../../../fstab.css" rel="stylesheet" type="text/css" />
<style>
#showupload, #cancelupload, .uploadimg{display:none;}
#menu{margin:-5px 5px 10px -5px;min-width:600px;}
#bmenu{margin-top:10px}
.lbut {height:48px; min-width:200px;}
input.rmarg{margin-right:15px;}

#stdbuts button{border: 0; background: transparent;}
#stdbuts button {border: 2px solid #F0F0F0;}
#stdbuts button:hover{border: outset 2px gray;}
h1 {text-align:left}
</style>
<script type='text/javascript' src='../../../wfm/wfm.js'></script>
<script type='text/javascript' src='editcont.js'></script>
<script type='text/javascript'>
$(function() {
   function checkExt(name) {
      var filter=true;
      try {
         var regexp=/^.*\.([^\.]*)$/m;
         var x=name.match(regexp);
         var ext=x[1].toLowerCase();
         filter=ext!="csv";
      }
      catch(e){alert(e);}
      if(filter) alert("You are attempting to upload a file with a non supported file extension!");
      return filter;
   }
   try {
      var xhr = new XMLHttpRequest();
      xhr.upload.addEventListener("progress", function(){},false);
      $('<div id="overlaymask"></div>').appendTo('body');
      window.dropURL=window.location.href+"?name="+$("#name").attr("value"); //For WFM drag & drop
      window.dropFilter=checkExt;
      $(".uploadimg").show().click(function() {
         alert("Your browser supports drag and drop upload.\nYou can import your e-mails by dropping your CSV file into the browser window.");
         $(this).blur();
         return false;
      });
   }
   catch(e) {}
   $("#uploadcont").hide();
   $("#cancelupload").show().click(function() {
      $("#stdbuts").show();
      $("#uploadcont").hide();
      $(this).blur();
      return false;
   });
   $("#showupload").show().click(function() {
      $("#stdbuts").hide();
      $("#uploadcont").show();
      $(this).blur();
      return false;
   });
   $("#delete").click(function() {
     var x=confirm('Do you want to delete this list and all contacts in this list?');
     if(x) return true;
     $(this).blur();
     return false;
   });
   $("#selall").click(function() {
      $("#fstab input").attr("checked","checked");
      $(this).blur();
   });
});
</script>
]]
   showHeader()
?>
<div class="roundedbox" id="menu">
<table><tr>
<td><h1><?lsp=data.name?></h1></td>
<td><?lsp for line in description:gmatch("[^\n]+") do w(line,"<br/>") end ?></td>
</tr></table>
<form method="post">
<input type="hidden" name="offset" value="<?lsp=offset?>"/>
<table id="stdbuts"><tr>
<?lsp if size > 100 then ?>
<td><button title="Backward" type="submit" name="nav" value="<?lsp=offset-100?>" ><img src="../img/backward.png"/></button></td>
<td><?lsp=fmt("%u-%u of %u",offset,offset+100,size)?></td>
<td><button title="Forward" type="submit" name="nav" value="<?lsp=offset+100?>" ><img src="../img/forward.png"/></button></td>
<?lsp end ?>
<td><button title="Add Contact" type="submit" name="addsub" value="" ><img src="../img/user-add.png"/></button></td>
<td><button title="Contact confirmation request" type="submit" name="pwd" value="" ><img src="../img/mail-pwd.png"/></button></td>
<td><button title="Drag, Drop, and Upload Contacts" value="Drag And Drop" class="uploadimg"><img style="width:48px;height:48px" src="../../../images/dropbox64.png"/></button></td>
<td><button title="Upload Contacts" id="showupload" value="Upload Contacts" ><img src="../img/upload.png"/></button></td>
<td><button title="Edit List Information" type="submit" id="edit" name="edit" value="Edit List" ><img src="../img/edit-list.png"/></button></td>
<td><button title="Move All Contacts to Another List" type="submit" id="move" name="movelist" value="Move List" ><img src="../img/move.png"/></button></td>
<td><button title="Delete List and Contacts" type="submit" id="delete" name="deletelist" value="Delete List" ><img src="../img/delete.png"/></button></td>
</tr></table>
</form>
<input type="hidden" id="name" name="name" value="<?lsp=data.name?>"/>
<form method="post" enctype="multipart/form-data" action="<?lsp=fmt('%s?name=%s&upload=true',response:encoderedirecturl'',data.name)?>">
<table id="uploadcont"><tr>
<td class="uploadimg"><img src="../../../images/dropbox64.png"/></td>
<td><input type='file' name='CSV'/></td>
<td><input type="submit" value="Upload"/></td>
<td><input type="button" id="cancelupload" value="Cancel" /></td>
</tr></table>
</form>
</div>
<form>
<input type="hidden" id="name" name="name" value="<?lsp=data.name?>"/>
<div id='fstab'><table><thead><tr><th>E-Mail</th><th>First&nbsp;Name</th><th>Last&nbsp;Name</th></tr></thead><tbody>
<?lsp
   local function action(cur)
      local key,email,firstname,lastname = cur:fetch()
      while key do
         w('<tr><td><input class="rmarg" type="checkbox" name="deletesub" value="',key,'"><a href="list.lsp?subkey=',key,'&offset=',offset,'">',email,'</a></td><td>',firstname,'</td><td>',
                        lastname,'</td></tr>')
         key,email,firstname,lastname = cur:fetch()
      end
   end
   sqlutil.select(conn,fmt('%s%s  ORDER BY email LIMIT %u,100',"key,email,firstname,lastname FROM mailcontact WHERE listkey=",listkey,offset), action)
?>
</tbody></table></div>
<?lsp if size ~= 0 then ?>
<div class="roundedbox" id="bmenu">
<table id="stdbuts"><tr>
<?lsp if size > 100 then ?>
<td><button title="Backward" type="submit" name="nav" value="<?lsp=offset-100?>" ><img src="../img/backward.png"/></button></td>
<td><?lsp=fmt("%u-%u of %u",offset,offset+100,size)?></td>
<td><button title="Forward" type="submit" name="nav" value="<?lsp=offset+100?>" ><img src="../img/forward.png"/></button></td>
<?lsp end ?>
<td><input class="lbut" id="selall" type="button" value="Select All" /></td>
<td><input class="lbut" type="submit" value="Delete Selected Contacts" /></td>
</tr></table>
</form>
</div>
<?lsp
end
end
-----------------showList------------------------------



------------------------------------------------------
function editList()
   local name,description,info
   if listkey then
      name,description = sqlutil.find(conn,"name,description FROM maillist WHERE key="..listkey)
   end
   if name then
      info="Save "..name
   else
      info="Create New List"
      name = data.name or ""
      description = data.description or ""
   end
   title=fmt("%s: %s",title,info)
   headerdata=[[
<style>
textarea {width:100%;height:200px}
.roundedbox { margin:10px;}
#subdiv input {width:150px;}
</style>
<script type='text/javascript'>function zz(){return false;} $(function(){$('body').bind('dragover',zz).bind('drop',zz);});</script>
]]
   showHeader()
?>
<div class="roundedbox">
<form method="POST">
<table>
<tr>
<td>Name:</td>
<td><input type="text" name="newname" value="<?lsp=name?>" /></td>
</tr>
</table>
<br/>
<fieldset><legend><b>Description</b></legend>
<textarea name="description"><?lsp=description?></textarea>
</fieldset>
<br/>
<div id="subdiv">
<input type="submit" name="save" value="<?lsp=info?>" />
<input type="submit" name="cancel" value="Cancel" />
</div>
</form>
</div>
<?lsp
end
---------------- editList -----------------------------
-------------------------------------------------------
local function manageContact()
   local ok,err,err2
   local email=data.email
   if data.save and email and data.firstname and data.lastname and data.listkey then
      local function duperr()
         return "E-Mail address is already registered in database"
      end
      local e=email:lower()
      local x=e:match"[^<]*<([^>]*)>.*"
      e = x or e
      local email=e:match("^[^@]-@[^@]+%.%a%a?%a?%a$") and e:gsub("'","''")
      if not email then
         err="Invalid E-Mail address"
      elseif data.subkey then
         local checkkey=mailutil.findemail(conn,email)
         if checkkey and checkkey ~= data.subkey then
            err=duperr()
         else
            local id=data.id and #data.id>0 and quote(data.id) or "NULL"
            local sqlfmt=fmt("%s%s%s",
                          "UPDATE mailcontact SET email=%s,firstname=%s,lastname=%s,id=%s,listkey=%u",
                          data.delpwd and ",password=NULL" or "",
                          " WHERE key=%u")
            ok,err,err2=mailutil.sqlexec(
               conn,
              fmt(sqlfmt,
                  quote(email),
                  quote(data.firstname),
                  quote(data.lastname),
                  id,
                  tonumber(data.listkey),
                  tonumber(data.subkey)))
         end
      elseif checkIfUniqueEmail(email) then
         ok,err,err2=mailutil.insertcontact(conn,listkey,email,data.firstname,data.lastname)
      else
         err=duperr()
      end
      err = err2 and fmt("%s %s",err,err2) or err
      if data.iframe then
         local rsp
         if err then
            rsp={err=err}
         else
            local listname
            if data.listkey == "0" then
               listname=""
            else
               listname=sqlutil.find(conn,"name FROM maillist WHERE key="..data.listkey)
            end
            rsp={email=email,firstname=data.firstname,lastname=data.lastname,listname=listname}
         end
         w('<html><head><script>parent.onEdit(eval(',
                        ba.json.encode(rsp),
                        '));</script></head><body></body></html>')
         return
      end
      if ok then redir2list() end
   end
   local function doList()
      local function emitOption(key,name,selected)
         selected = selected and ' selected="selected"' or ''
         w('<option value="',key,'"',selected,'>',name,'</option>')
      end
      sqlutil.select(conn,'key,name FROM maillist', function(cur)
         local key,name = cur:fetch()
         local found=false
         while key do
            if not found then found = listkey == key end
            emitOption(key,name,listkey == key)
            key,name = cur:fetch()
         end
         emitOption(0,"----------",not found)
      end)
   end

   headerdata=[[
<style>
#contact {width:400px;margin:auto}
#contact input {width: 100px;height:30px;}
#contact table, #contact table input[type=text], #contact table select {width:290px;height:20px;}
</style>
]]
local pwdset
if data.subkey then
   pwdset = sqlutil.find(conn,"password FROM mailcontact WHERE key="..data.subkey) and true
end
if data.iframe then
   w('<html><head><style>body{background:#33393D;color:white;}\n*{margin:0;padding:0}</style>',headerdata,'</head><body><div id="contact">')
else
   addListTxt=(data.subkey and "Edit" or "Add").." Contact"
   title=baseTitle..addListTxt
   showHeader()
?>
<h1><?lsp=data.name and fmt("%s: %s",data.name,addListTxt) or addListTxt?></h1>
<?lsp if err then w("<b style='color:red'>",err,"</b>") end ?>
<div id="contact" class="roundedbox">
<?lsp
end
?>
<form method="POST">
<table>
<tr><td>List:</td><td><select name="listkey"><?lsp doList() ?></select></td></tr>
<tr><td>E-Mail:</td><td><input type="text" name="email" value="<?lsp=email or ''?>"/></td></tr>
<tr><td>First&nbsp;Name:</td><td><input type="text" name="firstname" value="<?lsp=data.firstname or ''?>"/></td></tr>
<tr><td>Last&nbsp;Name:</td><td><input type="text" name="lastname" value="<?lsp=data.lastname or ''?>"/></td></tr>
<tr><td>ID:</td><td><input type="text" name="id" value="<?lsp=data.id or ''?>"/></td></tr>
<?lsp if pwdset then ?><tr><td><input type="checkbox" name="delpwd"/></td><td>Reset Password</td></tr><?lsp end ?>
</table>
<input type="hidden" name="addsub" value="save"/>
<input type="hidden" name="name" value="<?lsp=data.name?>"/>
<input type="hidden" name="offset" value="<?lsp=getOffset()?>"/>
<?lsp if data.subkey then w('<input type="hidden" name="subkey" value="',data.subkey,'"/>') end?>
<input type="submit" name="save" value="Save" style="margin-top:10px" />
</form>
<form method="POST" style="float:right;margin-top:-30px">
<input type="hidden" name="name" value="<?lsp=data.name?>"/>
<input type="hidden" name="offset" value="<?lsp=getOffset()?>"/>
<?lsp if not data.iframe then ?><input type="submit" name="cancel" value="Cancel" /><?lsp end?>
</form>
</div>
<?lsp
   if not data.iframe then
      showFooter()
   end
end

local function movelist()
   if data.flk and data.lk then
      if data.move then
         local sql=fmt("UPDATE mailcontact SET listkey=%s WHERE listkey=%s",data.lk,data.flk)
         local ok,e1,e2=conn:execute(sql)
         if not ok then
            trace("SQL maillist err:",sql," : ",e1,e2)
         end
      end
      redir2list()
   elseif data.cancel then
      redir2list()
   end
   showHeader()
   local lists={}
   local keys={}
   local function action(cur)
      local key,name = cur:fetch()
      while key do 
         keys[name]=key
         if data.name ~= name then
            tinsert(lists,name)
         end
         key,name = cur:fetch()
      end
   end
   sqlutil.select(conn,'key,name FROM maillist', action)
   response:write("<form method='POST'><div class='roundedbox'><h1>Move contacts in list '",
                  data.name,
                  "'</h1><input type='hidden' name='movelist' value='1'/><input type='hidden' name='flk' value='",
                  keys[data.name],"'/>")

   if #lists > 0 and keys[data.name] then
      response:write('<fieldset id="lists"><legend>Move all contacts to list:</legend><select style="min-width:200px" name="lk">')
      for _,n in ipairs(lists) do
         response:write('<option value="',keys[n],'">',n,'</option>')
      end
      response:write'</select><br/><input type="submit" name="move" value="Move"/><input type="submit" name="cancel" value="Cancel"/></fieldset>'
   else
      response:write'<p>You need at least two lists!</p><input type="submit" name="cancel" value="Cancel"/>'
   end
   print'</div></form>'
   showFooter()
end


---------------manageContact -------------------------


------------------------------------------------------
local function groupManagement()
   showHeader()
   showFooter()
end
---------------groupManagement------------------------



------------------------------------------------------
local function upload(method,name)
   local csv,err
   local dt={}
   local size=0
   local function filedata(data)
      if not err then
         size = size + #data
         if size > 1024*1024 then
            err = "Uploaded file too large. File must be smaller than 1Mbyte."
         end
         tinsert(dt,data)
      end
   end
   if method == "PUT" then
      for data in request:rawrdr() do
         filedata(data)
      end
   else
      request:multipart{
         beginfile=function() end, -- Required, but not used.
         filedata=filedata,
         error=function(e) err=e end
      }
   end
   if not err then
      csv,err=bd.csv(table.concat(dt),true)
   end
   if csv then
      if #csv == 0 then
         csv=nil
         err="Uploaded CSV file is empty"
      else
         session.maillist={csv=csv,name=name}
      end
   end
   if method == "PUT" then -- Ajax drag & Drop
      local action = csv and "location.reload(true)" or fmt("alert('%s')",err or "?")
      response:json{execjs=action}
   end
   if csv then
      response:sendredirect""
   end
   showHeader()
   w("<h1>Upload failed</h1><p>",err or "?",".</p><p>Press the back button to continue.</p>")
   showFooter()
end
-------------------- upload --------------------------



------------------- showImport -----------------------
local function emitCombo(col,option)
   local isSel
   local function getSel(val)
      if not isSel and val == option then
         isSel=true
         return ' selected="selected"'
      end
      return ''
   end
   local options={
      {"","-Skip-"},
      {"email","E-Mail"},
      {"firstname","First Name"},
      {"lastname","Last Name"},
   }
   w('<td><select name="',col,'">')
   for _,v in ipairs(options) do
      w('<option value="',v[1],'"',getSel(v[1]),'>',v[2],'</option>')
   end
   w'</select></td>'
end

local colnames={
   ["e-mail"]="email",
   ["email"]="email",
   ["primary email"]="email",
   ["e-mail address"]="email",
   ["e-mail 1 - value"]="email",
   ["name"]="firstname",
   ["firstname"]="firstname",
   ["first name"]="firstname",
   ["given name"]="firstname",
   ["yomi name"]="firstname",
   ["given name yomi"]="firstname",
   ["surname"]="lastname",
   ["lastname"]="lastname",
   ["last name"]="lastname",
   ["family name"]="lastname",
   ["family name yomi"]="lastname",
}

-------------------
local function showImport(csv, err)
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title>Import</title>
<link href="../../../fstab.css" rel="stylesheet" type="text/css" />
<style type="text/css">
#fstab th {background:#33393D url(/rtl/images/fondo-menu.png) top left repeat-x;}
#colsel td { padding-top: 10px;}
input { padding:5px 15px 5px 15px; margin-left:30px;}
#overlaymask {
  position:absolute;
  top:0;
  left:0;
  z-index:9000;
  background-color:#888;
  display:none;
}
</style>
<script type='text/javascript' src='/rtl/jquery.js'></script>
<script type="text/javascript" src="/rtl/showwait.js"></script>
<script type="text/javascript">
$(function(){
   $("#import").click(function() {
      $("#fstab").hide();
      showwait();
   });
});
</script> 
</head>
<body>
<h1>Import to <?lsp=data.name?></h1>
<?lsp if err then w('<p><b style="color:red">',err,'</b></p>') end ?>
<h3>Select Columns:</h3>
<form method="post"><div id="fstab"><table>
<?lsp
   local t={}
   w'<tr>'
   for col,val in ipairs(csv[1]) do
      w('<th>',col,'</th>')
   end
   w'</tr><tr id="colsel">'
   for col,val in ipairs(csv[1]) do
      local x=colnames[val:lower()]
      local found
      if x and not t[x] then t[x]=true found=true end
      emitCombo(col, found and x)
   end
   w'</tr>'
   for row,rowt in ipairs(csv) do
      if row > 100 then break end
      w"<tr>"
      for col,v in ipairs(rowt) do
         if #v > 0 then
            w("<td>",v,"</td>")
         else
            w("<td></td>")
         end
      end
      w"</tr>\n"
   end
?>
</table></div>
<?lsp if #csv > 100 then ?><p><b>Note</b>: only 100 out of <?lsp=#csv?> rows are shown above.</p><?lsp end ?> 
<br/>
<input type="submit" id="import" name="import" value="Import" />
<input type="submit" name="discard" value="Discard" />
</form>
</body></html>
<?lsp
end
-------------------- showImport-----------------------


-------------------- saveImport ----------------------


local function getActions(d)
   local actions={}
   local function emailFact(col)
      local function action(row)
         local e=row[col]:lower()
         local x=e:match"[^<]*<([^>]*)>.*"
         e = x or e
         return e:match("^[^@]-@[^@]+%.%a%a?%a?%a$") and e:gsub("'","''")
      end
      return action
   end
   local function genericColFact(col)
      return function(row) return row[col]:gsub("'","''") end
   end
   local actionFact={
      email=emailFact,
      firstname=genericColFact,
      lastname=genericColFact,
   }
   local checkT={}
   for k,v in pairs(d) do
      local col=tonumber(k)
      if col then
         if not actions[v] then
            if actionFact[v] then
               actions[v]=actionFact[v](col)
               checkT[v]=col
            end
         elseif #v > 0 then
            return nil, fmt("Column %d and %d cannot be the same",checkT[v],col)
         end
      end
   end
   if actions.email then
      return actions
   end
   return nil, "The column with the email address is required"
end

local function importStatistics(insertcnt,invalidcnt,duplicatecnt)
?>
<h1>Import List: Statistics</h1>
<p><br/></p>
<div class="roundedbox" style="width:300px;margin:auto">
<table>
<tr><td>Contacts imported:</td><td><?lsp=insertcnt?></td></tr>
<tr><td>Invalid E-Mail addresses:</td><td><?lsp=invalidcnt?></td></tr>
<tr><td>Duplicate and ignored entries:</td><td><?lsp=duplicatecnt?></td></tr>
</table>
</div>
<p><br/></p>
<a href="<?lsp=getredir()?>">Continue</a>         
<?lsp
end


--------------------
local function saveImport(url)
   local ok
   local csv=session.maillist.csv
   local actions,err=getActions(data)
   if actions then
      local err2=""
      conn:setautocommit("IMMEDIATE",5000)
      local function noAction() return "" end
      setmetatable(actions,{__index=function() return noAction end})
      local invalidcnt,duplicatecnt,insertcnt=0,0,0
      local totRows=#csv
      for rowix,row in ipairs(csv) do
         local email=actions.email(row)
         if email then
            if checkIfUniqueEmail(email) then
               ok,err,err2=mailutil.insertcontact(conn,listkey,email,actions.firstname(row),actions.lastname(row))
               if not ok then break end
               insertcnt=insertcnt+1
            else
               duplicatecnt=duplicatecnt+1
            end
         else
            invalidcnt=invalidcnt+1
         end
      end
      if ok then
         conn:commit()
         session.maillist=nil
      else
         if err then
            err = err2 and fmt("%s %s",err,err2) or err
         else
            assert(insertcnt==0)
            session.maillist=nil
            ok=true
         end
         conn:rollback()
      end
      if ok then
         showHeader()
         importStatistics(insertcnt,invalidcnt,duplicatecnt)
         showFooter()
      end
   end
   if not ok then
      showImport(csv,err)
   end
end
-------------------- saveImport ----------------------



if session.maillist then
   data.name = session.maillist.name
end

env,conn = bd.openDb"bd"
if data.name or data.newname then
   sqlutil=require"sqlutil"
   mailutil=require"mailutil"
   if data.name then
      listkey,description=
         sqlutil.find(conn,"key,description FROM maillist WHERE name="..quote(data.name))
   end
   if listkey then
      addListTxt = "Edit List"
      title=baseTitle..addListTxt
      local method=request:method()
      if method == "PUT" or data.upload then
         closeDb()
         upload(method,data.name)
         return
      end
      if session.maillist then
         if data.import then
            saveImport()
         elseif data.discard then
            session.maillist=nil
            redir2list()
         else
            showImport(session.maillist.csv)
         end
         closeDb()
         response:abort()
      end
      if data.addsub then
         manageContact()
         closeDb()
         response:abort()
      end
      if data.gm then
         groupManagement()
         response:abort()
      end
      if data.deletelist then
         closeDb(fmt("dl.lsp?name=%s", ba.urlencode(data.name)))
      elseif data.movelist then
         addListTxt = "Move List"
         title=baseTitle..addListTxt
         movelist()
         response:abort()
      end
      if data.save and data.newname and data.description then
         mailutil.sqlexec(conn,fmt("UPDATE maillist SET name=%s, description=%s WHERE key=%s",
                          quote(data.newname),
                          quote(data.description),
                          listkey))
         redir2list()
      end
   else
      session.maillist=nil
   end
   if data.save and data.newname and data.description then
      local inList=sqlutil.find(conn,"key FROM maillist WHERE name="..quote(data.newname))
      if inList or (not bd.businesslic() and tonumber(sqlutil.find(conn,"count(*) FROM maillist")) >= 1) then
         closeDb()
         showHeader()
         w('<h1>',inList and 'List name already in database' or 'Personal license is limited to one list',
           '</h1><p><a href="list.lsp">Continue</a></p>')
         showFooter()
         response:abort()
      end
      mailutil.sqlexec(conn,fmt("INSERT INTO maillist (name,description) VALUES (%s,%s)",
                                quote(data.newname),
                                quote(data.description)))
      redir2list()
   end
end

if data.pwd and listkey then
   closeDb(fmt("contactspwd.lsp?key=%s&offset=%u",listkey,getOffset()))
end

if data.subkey then
   sqlutil=require"sqlutil"
   data.email,data.firstname,data.lastname,data.id,listkey,data.name=
      sqlutil.find(conn,fmt("email,firstname,lastname,id,listkey,(SELECT name FROM maillist WHERE key=listkey) FROM mailcontact WHERE key=%u",tonumber(data.subkey)))
   --if listkey then
      if data.cancel then redir2list() end
      manageContact()
      closeDb()
      return
   --end
end
if not listkey or data.edit then
   editList()
else
   if data.deletesub then
      local tab={}
      local ins=table.insert
      for n,v in request:datapairs() do
         if n == "deletesub" and tonumber(v) then ins(tab,v) end
      end
      local sql=fmt("DELETE FROM mailcontact WHERE key IN (%s)",table.concat(tab,","))
      local ok,e1,e2=conn:execute(sql)
      if not ok then
         trace("SQL maillist err:",sql," : ",e1,e2)
      end
      redir2list()
   end
   showList()
end
showFooter()
closeDb()
?>
