function getWinPos()
{
   var w;
   var h;
   if (self.innerWidth) {
      w = self.innerWidth;
      h = self.innerHeight;
   }
   else if (document.documentElement && document.documentElement.clientWidth){
      w = document.documentElement.clientWidth;
      h = document.documentElement.clientHeight;
   }
   else if (document.body) {
      w = document.body.clientWidth;
      h = document.body.clientHeight;
   }
   else {
      w=400;
      h=400;
   }
   return {w:w,h:h};
};


function hlpUsername()
{
   return "<h3>Username:</h3><p>The name the user must use when logging into your FuguHub web-server. Avoid using spaces in the name. Username examples are: david, thomas, and james.</p>";
};

function hlpPassword()
{
   return "<h3>Password:</h3><p>Give the user an initial password. The user can later login to your server using the initial password and change his/her password.</p>";
};

function hlpBasepath()
{
   return "<h3>Base path:</h3><p><b>The Web File Manager and the WebDAV server base directory for the users added to the FuguHub user database.</b></p><p>FuguHub suggests a base path for the user's home directory. The suggested path depends on your platform and installation. The path may, for example, be /c/bdusers/ on a Windows computer. This corresponds to c:\\bdusers on your hard drive.</p><p>The name bdusers indicates FuguHub users. You can change this name and the path. The path can also be to a network storage device on your network. Just remember to use forward slash on Windows and not backward slash.</p><p>The simplified ACL manager attempts to create the base directory and a sub directory in the base directory for each user added. You must make sure the web server has access rights to create this directory. This is normally not a problem on Windows, but may be a problem if you are running FuguHub on UNIX, Mac OS X, or Linux.</p><p><b>Windows \"My Documents\" example:</b></p><p>If your home directory on the Windows computer is:<br/>c:\\Documents and Settings\\All Users\\My Documents</p><p>You can use this directory as the base path by changing the path to:<br/>/c/Documents and Settings/All Users/My Documents</p><p><b>See the \"Add User\" help button for more information</b>.</p>";
};

function hlpSave()
{
   return '<h3>Add User:</h3><p>Assume that you add user "thomas" using "base path" /c/bdusers. The simplified ACL manager does the following when you press the "Add User" button:</p><ul><li>Creates the user\'s home directory on your hard drive. The home directory is base path + username. This is c:\\bdusers\\thomas for our example.</li><li>The web-server creates a common directory where all your friends can share documents. The common directory is in our example c:\\bdusers\\common.</li><li>Sets up a constraint that gives the user read only access to c:\\bdusers. The user cannot navigate outside of this directory. He can read files from c:\\bdusers, but not write files to this directory.</li><li>Sets up a constraint that gives the user read and write access to c:\\bdusers\\thomas</li><li>Sets up a constraint that gives the user read and write access to c:\\bdusers\\common. The users are not allowed to visit each others home directory.</li></ul><h3>Example:</h3>  <div style="margin-left:3em">  <p><b>Assume we add two users, thomas and james:</b></p><table border="1"><tr><th>Path</th><th>Access thomas</th><th>Access james</th></tr><tr><td>c:\\bdusers</td><td>Read</td><td>Read</td></tr><tr><td>c:\\bdusers\\common</td><td>Read and write</td><td>Read and write</td></tr><tr><td>c:\\bdusers\\thomas</td><td>Read and write</td><td>No access</td></tr><tr><td>c:\\bdusers\\james</td><td>No access</td><td>Read and write</td></tr><tr><td>Any other directory</td><td>No access</td><td>No access</td></tr></table></div>';
};


function initHelp()
{
   $("img[hlp]").mouseover(function(e) {
      $("#help").html("<h1>Loading help...</h1>");
      var ws = getWinPos();
      var calcWidth = e.pageX - 100;
      if(calcWidth<20) calcWidth=20;
      var h = parseInt(calcWidth*1.3333);
      var y = e.pageY - h;
      var offs;
      if(window.pageYOffset) offs=window.pageYOffset;
      else offs = document.documentElement.scrollTop;
      offs +=5;
      if(y < offs) y = offs;
      var hlp = {
         username:hlpUsername,
         password:hlpPassword,
         basepath:hlpBasepath,
         save:hlpSave
      };
      $("#help").show().css("top",y).width(calcWidth).html(hlp[$(this).attr('hlp')](this));
   }).mouseout(function() {
      $("#help").hide();
   });
};


onload=function(){
   initHelp();
};
